module Day1 (day1) where

import qualified Data.IntSet as DIS
import Data.Maybe (mapMaybe)

type Target = Int

type Expenses = [Int]

type Expenses' = DIS.IntSet

day1 :: IO ()
day1 = do
  r <- readFile "./input/day1"
  putStr "[Day 1-1] fix: "
  print . fixExpenseReport 2020 2 . fmap read . lines $ r
  putStr "[Day 1-2] fix: "
  print . fixExpenseReport 2020 3 . fmap read . lines $ r

-- Turn the list into an IntSet. For each element in the set, look up the
-- number in the set to make it 2020. If found, return the multiplication of
-- the two numbers.
fixExpenseReport :: Target -> Int -> Expenses -> Maybe Int
fixExpenseReport t c es
  | c <= 0 = error "unsupported"
  | otherwise = fixExpenseReport' t c (DIS.fromList es)

fixExpenseReport' :: Target -> Int -> Expenses' -> Maybe Int
fixExpenseReport' t 1 es = if DIS.member t es then Just t else Nothing
fixExpenseReport' t c es =
  let foo x = (* x) <$> fixExpenseReport' (t - x) (c -1) (DIS.delete x es)
      bar = mapMaybe foo (DIS.toList es)
   in case bar of
        [] -> Nothing
        (x : _) -> Just x