module Day5 (day5) where

import Data.List (sort, (\\))

getRow :: String -> Integer
getRow = snd . foldr go (1, 0)
  where
    go 'F' (m, s) = (m * 2, s)
    go 'B' (m, s) = (m * 2, s + m)
    go _ _ = error "not possible"

getCol :: String -> Integer
getCol = snd . foldr go (1, 0)
  where
    go 'L' (m, s) = (m * 2, s)
    go 'R' (m, s) = (m * 2, s + m)
    go _ _ = error "not possible"

getSeat :: String -> (Integer, Integer)
getSeat s = let (row, col) = take 3 <$> splitAt 7 s in (getRow row, getCol col)

day5 :: IO ()
day5 = do
  r <- readFile "./input/day5"
  let m = lines r
  putStr "[Day 5-1] max id: "
  let ids = sort $ map ((\(a, b) -> 8 * a + b) . getSeat) m
  print . maximum $ ids
  putStr "[Day 5-2] my id: "
  print . head $ (enumFrom (head ids) \\ ids)